
(* A bench based on Church numbers *)

(* The Caml machine *)

let cfst p = p (fun x y -> x);;
let csnd p = p (fun x y -> y);;
let cpair x y = (fun c -> c x y);;

type 'a nat = ('a -> 'a) -> 'a -> 'a;;

(* Cheat typing *)
external hack_nat : 'a nat -> 'b nat = "%identity";;

let int_of_ch (c : 'a nat) =
  lam_list 2 (c (fun t -> App(Rel 1, t)) (Rel 0))
;;

let zero =
  let zero s o = o
  in (zero : 'a nat)
;;

let ten =
  let ten s o = (s (s (s (s (s (s (s (s (s (s o))))))))))
  in (ten : 'a nat)
;;

let hundred =
  let hundred s o =
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
  o
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
  in (hundred:'a nat)
;;

let twohundred =
  let twohundred s o =
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s 
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s
  o
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
                          ))))))))))
  in (twohundred : 'a nat)
;;

let fourhundred = 
  let fourhundred s o =
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 o
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
  in (fourhundred : 'a nat)
;;

let thousand =
  let thousand s o =
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s (s
 o
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
                          ))))))))))))))))))))
  in (thousand : 'a nat)
;;

let csucc (n:'a nat) =
  ((fun s o -> (s (n s o))) : 'a nat);;
let cmult (m:'a nat) (n:'b nat) =
  ((fun s o -> (hack_nat m (n s) o)) : 'c nat);;

let pair_succ p =
  let fp = cfst p in
    cpair (csucc fp) fp;;

(*
let pair_succ p =
  cpair (csucc (cfst p)) (cfst p);;
*)

let cpred n =
  (csnd (hack_nat n pair_succ (cpair zero zero)) : 'b nat)
;;

(* n times the predecessor of n *)
let nzero (n:'a nat) = hack_nat n cpred n;;

(* k-uple of term n. Ocaml cannot give it a type. *)
let ntuple (k:'a nat) n =
  Obj.magic k (fun p -> cpair p n) n;;

let cttu k n = (ntuple k (nzero n));;

